Overview | Package | Class | Tree | Deprecated | Index | Help
Qt Jambi Home |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.core
Class QDate

    java.lang.Object
      com.trolltech.qt.QSignalEmitter
          com.trolltech.qt.QtJambiObject
              com.trolltech.qt.core.QDate

All Implemented Interfaces:
  QtJambiInterface, java.lang.Comparable

    public class QDate

extends QtJambiObject
implements java.lang.Comparable

The `QDate` class provides date functions.

A `QDate` object contains a calendar date, i.e. year, month, and day numbers, in the Gregorian calendar (Julian calendar for dates before 15 October 1582). It can read the current date from the system clock. It provides functions for comparing dates, and for manipulating dates. For example, it is possible to add and subtract days, months, and years to dates.

A `QDate` object is typically created either by giving the year, month, and day numbers explicitly, or by using the static function `currentDate` that creates a `QDate` object containing the system clock's date. An explicit date can also be set using `setDate`. The `fromString` function returns a `QDate` given a string and a date format which is used to interpret the date within the string.

The `year`, `month`, and `day` functions provide access to the year, month, and day numbers. Also, `dayOfWeek` and `dayOfYear` functions are provided. The same information is provided in textual format by the `toString`, `shortDayName`, `longDayName`, `shortMonthName`, and `longMonthName` functions.

`QDate` provides a full set of operators to compare two `QDate` objects where smaller means earlier, and larger means later.

You can increment (or decrement) a date by a given number of days using `addDays`. Similarly you can use `addMonths` and `addYears`. The `daysTo` function returns the number of days between two dates.

The `daysInMonth` and `daysInYear` functions return how many days there are in this date's month and year, respectively. The `isLeapYear` function indicates whether this date is in a leap year.

Note that the Gregorian calendar was introduced at different dates in different countries and regions. `QDate` uses the Gregorian calendar starting from 15 October 1582, and uses the Julian calendar for dates up to 4 October 1582.

See Also:
  `QTime`, `QDateTime`, `QDateEdit`, `QDateTimeEdit`, `QCalendarWidget`

Nested Class Summary

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.AbstractSignal, QSignalEmitter.Signal0, QSignalEmitter.Signal1<A>, QSignalEmitter.Signal2<A,B>, QSignalEmitter.Signal3<A,B,C>, QSignalEmitter.Signal4<A,B,C,D>, QSignalEmitter.Signal5<A,B,C,D,E>, QSignalEmitter.Signal6<A,B,C,D,E,F>, QSignalEmitter.Signal7<A,B,C,D,E,F,G>, QSignalEmitter.Signal8<A,B,C,D,E,F,G,H>, QSignalEmitter.Signal9<A,B,C,D,E,F,G,H,I>`

Constructor Summary
`QDate()` Constructs a null date.
`QDate(int y, int m, int d)` Constructs a date with year `y`, month `m` and day `d`.

Method Summary
`QDate` | `addDays(int days)` Returns a `QDate` object containing a date `days` later than the date of this object (or earlier if `days` is negative).
`QDate` | `addMonths(int months)` Returns a `QDate` object containing a date `months` later than the date of this object (or earlier if `months` is negative).
`QDate` | `addYears(int years)` Returns a `QDate` object containing a date `years` later than the date of this object (or earlier if `years` is negative).
`int` | `compareTo(java.lang.Object other)`
`static QDate` | `currentDate()` Returns the current date, as reported by the system clock.
`int` | `day()` Returns the day of the month (1 to 31) of this date.
`int` | `dayOfWeek()` Returns the weekday (1 to 7) for this date.
`int` | `dayOfYear()` Returns the day of the year (1 to 365) for this date.
`int` | `daysInMonth()` Returns the number of days in the month (28 to 31) for this date.
`int` | `daysInYear()` Returns the number of days in the year (365 or 366) for this date.
`int` | `daysTo(QDate arg__1)` Returns the number of days from this date to `arg__1` (which is negative if `arg__1` is earlier than this date).
`boolean` | `equals(java.lang.Object other)`
`static QDate` | `fromJulianDay(int jd)` Converts the Julian day `jd` to a `QDate`.
`static QDate` | `fromNativePointer(QNativePointer nativePointer)` This function returns the QDate instance pointed to by nativePointer
`static QDate` | `fromString(java.lang.String s)` Equivalent to `fromString`(`s`, Qt::TextDate).
`static QDate` | `fromString(java.lang.String s, Qt.DateFormat f)` Returns the `QDate` represented by the `s`, using the `f` given, or an invalid date if the string cannot be parsed.
`static QDate` | `fromString(java.lang.String s, java.lang.String format)` Returns the `QDate` represented by the `s`, using the `format` given, or an invalid date if the string cannot be parsed.
`static int` | `gregorianToJulian(int y, int m, int d)`
`static boolean` | `isLeapYear(int year)` Returns true if the specified `year` is a leap year; otherwise returns false.
`boolean` | `isNull()` Returns true if the date is null; otherwise returns false.
`boolean` | `isValid()` Returns true if this date is valid; otherwise returns false.
`static boolean` | `isValid(int y, int m, int d)` Returns true if the specified date (`y`, `m`, and `d`) is valid; otherwise returns false.
`static java.lang.String` | `longDayName(int weekday)` Returns the long name of the `weekday` using the following convention:
`static java.lang.String` | `longMonthName(int month)` Returns the long name of the `month` using the following convention:
`int` | `month()` Returns the number corresponding to the month of this date, using the following convention:
`static QNativePointer` | `nativePointerArray(QDate[] array)` This function returns a QNativePointer that is pointing to the specified QDate array.
`void` | `readFrom(QDataStream arg__1)` Reads a QDate from arg__1.
`boolean` | `setDate(int year, int month, int date)` Sets the date's `year`, `month`, and `date`.
`static java.lang.String` | `shortDayName(int weekday)` Returns the name of the `weekday` using the following convention:
`static java.lang.String` | `shortMonthName(int month)` Returns the name of the `month` using the following convention:
`int` | `toJulianDay()` Converts the date to a Julian day.
`java.lang.String` | `toString()` Equivalent to `toString`(Qt::TextDate).
`java.lang.String` | `toString(Qt.DateFormat f)` Returns the date as a string.
`java.lang.String` | `toString(java.lang.String format)` Returns the date as a string.
`int` | `weekNumber()` Returns the week number (1 to 53).
`void` | `writeTo(QDataStream arg__1)` Writes thisQDate to arg__1.
`int` | `year()` Returns the year of this date.
`int` | `yearOfWeekNumber()` This function returns the year number of the QDate's current week.

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`blockSignals, disconnect, disconnect, signalsBlocked, signalSender, thread`

Methods inherited from class java.lang.Object
`clone, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Constructor Detail

### QDate

    public QDate()

  Constructs a null date. Null dates are invalid.

  See Also:
    `isNull`, `isValid`

### QDate

    public QDate(int y,
                 int m,
                 int d)

  Constructs a date with year `y`, month `m` and day `d`.

  If the specified date is invalid, the date is not set and `isValid` returns false. Any date before 2 January 4713 B.C. is considered invalid.

  Warning: Years 0 to 99 are interpreted as is. If you want to specify the year 2010, you must write 2010, not 10.

  See Also:
    `isValid`

Method Detail

### addDays

    public final QDate addDays(int days)

  Returns a `QDate` object containing a date `days` later than the date of this object (or earlier if `days` is negative).

  See Also:
    `addMonths`, `addYears`, `daysTo`

### addMonths

    public final QDate addMonths(int months)

  Returns a `QDate` object containing a date `months` later than the date of this object (or earlier if `months` is negative).

  See Also:
    `addDays`, `addYears`

### addYears

    public final QDate addYears(int years)

  Returns a `QDate` object containing a date `years` later than the date of this object (or earlier if `years` is negative).

  See Also:
    `addDays`, `addMonths`

### day

    public final int day()

  Returns the day of the month (1 to 31) of this date.

  See Also:
    `year`, `month`, `dayOfWeek`

### dayOfWeek

    public final int dayOfWeek()

  Returns the weekday (1 to 7) for this date.

  See Also:
    `day`, `dayOfYear`, `Qt::DayOfWeek`

### dayOfYear

    public final int dayOfYear()

  Returns the day of the year (1 to 365) for this date.

  See Also:
    `day`, `dayOfWeek`

### daysInMonth

    public final int daysInMonth()

  Returns the number of days in the month (28 to 31) for this date.

  See Also:
    `day`, `daysInYear`

### daysInYear

    public final int daysInYear()

  Returns the number of days in the year (365 or 366) for this date.

  See Also:
    `day`, `daysInMonth`

### daysTo

    public final int daysTo(QDate arg__1)

  Returns the number of days from this date to `arg__1` (which is negative if `arg__1` is earlier than this date).

  Example:

          QDate d1(1995, 5, 17);  // May 17, 1995
          QDate d2(1995, 5, 20);  // May 20, 1995
          d1.daysTo(d2);          // returns 3
          d2.daysTo(d1);          // returns -3

  See Also:
    `addDays`

### isNull

    public final boolean isNull()

  Returns true if the date is null; otherwise returns false. A null date is invalid.

  See Also:
    `isValid`

### isValid

    public final boolean isValid()

  Returns true if this date is valid; otherwise returns false.

  See Also:
    `isNull`

### month

    public final int month()

  Returns the number corresponding to the month of this date, using the following convention:

  - 1 = "January"
  - 2 = "February"
  - 3 = "March"
  - 4 = "April"
  - 5 = "May"
  - 6 = "June"
  - 7 = "July"
  - 8 = "August"
  - 9 = "September"
  - 10 = "October"
  - 11 = "November"
  - 12 = "December"

  See Also:
    `year`, `day`

### writeTo

    public final void writeTo(QDataStream arg__1)

  Writes thisQDate to arg__1.

### readFrom

    public final void readFrom(QDataStream arg__1)

  Reads a QDate from arg__1.

### setDate

    public final boolean setDate(int year,
                                 int month,
                                 int date)

  Sets the date's `year`, `month`, and `date`. Returns true if the date is valid; otherwise returns false.

  If the specified date is invalid, the `QDate` object is set to be invalid. Any date before 2 January 4713 B.C. is considered invalid.

  See Also:
    `isValid`

### toJulianDay

    public final int toJulianDay()

  Converts the date to a Julian day.

  See Also:
    `fromJulianDay`

### toString

    public final java.lang.String toString()

  Equivalent to `toString`(Qt::TextDate).

  Overrides:
    `toString` in class `java.lang.Object`

### toString

    public final java.lang.String toString(Qt.DateFormat f)

  Returns the date as a string. The `f` parameter determines the format of the string.

  If the `f` is Qt::TextDate, the string is formatted in the default way. QDate::shortDayName() and QDate::shortMonthName() are used to generate the string, so the day and month names will be localized names. An example of this formatting is "Sat May 20 1995".

  If the `f` is Qt::ISODate, the string format corresponds to the ISO 8601 extended specification for representations of dates and times, taking the form YYYY-MM-DD, where YYYY is the year, MM is the month of the year (between 01 and 12), and DD is the day of the month between 01 and 31.

  If the `f` is Qt::LocalDate or Qt::SystemLocaleDate, the string format depends on the locale settings of the system. Identical to calling QLocale::system().`toString`(date, QLocale::ShortFormat). Qt::LocalDate has been deprecated, please use Qt::SystemLocaleDate instead.

  If the `f` is Qt::LocaleDate, the string format depends on the default application locale. This is the locale set with QLocale::setDefault(), or the system locale if no default locale has been set. Identical to calling QLocale().`toString`(date, QLocale::ShortFormat);

  If the datetime is invalid, an empty string will be returned.

  Warning: The Qt::ISODate format is only valid for years in the range 0 to 9999. This restriction may apply to Qt::LocalDate as well, depending on the locale settings.

  See Also:
    `shortDayName`, `shortMonthName`

### toString

    public final java.lang.String toString(java.lang.String format)

  Returns the date as a string. The `format` parameter determines the format of the result string.

  These expressions may be used:

  Expression | Output
  --- | ---
  d | the day as number without a leading zero (1 to31)
  dd | the day as number with a leading zero (01 to 31)
  ddd | the abbreviated localized day name (e.g. 'Mon' to 'Sun'). Uses QDate::shortDayName().
  dddd | the long localized day name (e.g. 'Qt::Monday' to 'Qt::Sunday'). Uses QDate::longDayName().
  M | the month as number without a leading zero (1-12)
  MM | the month as number with a leading zero (01-12)
  MMM | the abbreviated localized month name (e.g. 'Jan' to 'Dec'). Uses QDate::shortMonthName().
  MMMM | the long localized month name (e.g. 'January' to 'December'). Uses QDate::longMonthName().
  yy | the year as two digit number (00 to 99)
  yyyy | the year as four digit number

  All other input characters will be ignored. Any sequence of characters that are enclosed in singlequotes will be treated as text and not be used as an expression. Two consecutive singlequotes ("''") are replaced by a singlequote in the output.

  Example format strings (assuming that the `QDate` is the 20 July 1969):

  Format | Result
  --- | ---
  dd.MM.yyyy | 20.07.1969
  ddd MMMM d yy | Sun July 20 69
  'The day is' dddd | The day is Sunday

  If the datetime is invalid, an empty string will be returned.

  Warning: This function is only valid for years in the range 0 to 9999.

  See Also:
    `QDateTime::toString`, `QTime::toString`

### year

    public final int year()

  Returns the year of this date. Negative numbers indicate years before 1 A.D. = 1 C.E., such that year -44 is 44 B.C.

  See Also:
    `month`, `day`

### currentDate

    public static QDate currentDate()

  Returns the current date, as reported by the system clock.

  See Also:
    `QTime::currentTime`, `QDateTime::currentDateTime`

### fromJulianDay

    public static QDate fromJulianDay(int jd)

  Converts the Julian day `jd` to a `QDate`.

  See Also:
    `toJulianDay`

### fromString

    public static QDate fromString(java.lang.String s,
                                   java.lang.String format)

  Returns the `QDate` represented by the `s`, using the `format` given, or an invalid date if the string cannot be parsed.

  These expressions may be used for the format:

  Expression | Output
  --- | ---
  d | The day as a number without a leading zero (1 to 31)
  dd | The day as a number with a leading zero (01 to 31)
  ddd | The abbreviated localized day name (e.g. 'Mon' to 'Sun'). Uses QDate::shortDayName().
  dddd | The long localized day name (e.g. 'Monday' to 'Sunday'). Uses QDate::longDayName().
  M | The month as a number without a leading zero (1 to 12)
  MM | The month as a number with a leading zero (01 to 12)
  MMM | The abbreviated localized month name (e.g. 'Jan' to 'Dec'). Uses QDate::shortMonthName().
  MMMM | The long localized month name (e.g. 'January' to 'December'). Uses QDate::longMonthName().
  yy | The year as two digit number (00 to 99)
  yyyy | The year as four digit number

  All other input characters will be treated as text. Any sequence of characters that are enclosed in single quotes will also be treated as text and will not be used as an expression. For example:

          QDate date = QDate::fromString("1MM12car2003", "d'MM'MMcaryyyy");
          // date is 1 December 2003

  If the format is not satisfied, an invalid `QDate` is returned. The expressions that don't expect leading zeroes (d, M) will be greedy. This means that they will use two digits even if this will put them outside the accepted range of values and leaves too few digits for other sections. For example, the following format string could have meant January 30 but the M will grab two digits, resulting in an invalid date:

          QDate date = QDate::fromString("130", "Md"); // invalid

  For any field that is not represented in the format the following defaults are used:

  Field | Default value
  --- | ---
  Year | 1900
  Month | 1
  Day | 1

  The following examples demonstrate the default values:

          QDate::fromString("1.30", "M.d");           // January 30 1900
          QDate::fromString("20000110", "yyyyMMdd");  // January 10, 2000
          QDate::fromString("20000110", "yyyyMd");    // January 10, 2000

  See Also:
    `QDateTime::fromString`, `QTime::fromString`, `QDate::toString`, `QDateTime::toString`, `QTime::toString`

### fromString

    public static QDate fromString(java.lang.String s)

  Equivalent to `fromString`(`s`, Qt::TextDate).

### fromString

    public static QDate fromString(java.lang.String s,
                                   Qt.DateFormat f)

  Returns the `QDate` represented by the `s`, using the `f` given, or an invalid date if the string cannot be parsed.

  Note for Qt::TextDate: It is recommended that you use the English short month names (e.g. "Jan"). Although localized month names can also be used, they depend on the user's locale settings.

  Warning: Qt::LocalDate cannot be used here.

### gregorianToJulian

    public static int gregorianToJulian(int y,
                                        int m,
                                        int d)

### isLeapYear

    public static boolean isLeapYear(int year)

  Returns true if the specified `year` is a leap year; otherwise returns false.

### isValid

    public static boolean isValid(int y,
                                  int m,
                                  int d)

  Returns true if the specified date (`y`, `m`, and `d`) is valid; otherwise returns false.

  Example:

          QDate::isValid(2002, 5, 17);  // true
          QDate::isValid(2002, 2, 30);  // false (Feb 30 does not exist)
          QDate::isValid(2004, 2, 29);  // true (2004 is a leap year)
          QDate::isValid(2000, 2, 29);  // true (2000 is a leap year)
          QDate::isValid(2006, 2, 29);  // false (2006 is not a leap year)
          QDate::isValid(2100, 2, 29);  // false (2100 is not a leap year)
          QDate::isValid(1202, 6, 6);   // true (even though 1202 is pre-Gregorian)

  See Also:
    `isNull`, `setDate`

### longDayName

    public static java.lang.String longDayName(int weekday)

  Returns the long name of the `weekday` using the following convention:

  - 1 = "Monday"
  - 2 = "Tuesday"
  - 3 = "Wednesday"
  - 4 = "Thursday"
  - 5 = "Friday"
  - 6 = "Saturday"
  - 7 = "Sunday"

  The day names will be localized according to the system's locale settings.

  See Also:
    `toString`, `shortDayName`, `shortMonthName`, `longMonthName`

### longMonthName

    public static java.lang.String longMonthName(int month)

  Returns the long name of the `month` using the following convention:

  - 1 = "January"
  - 2 = "February"
  - 3 = "March"
  - 4 = "April"
  - 5 = "May"
  - 6 = "June"
  - 7 = "July"
  - 8 = "August"
  - 9 = "September"
  - 10 = "October"
  - 11 = "November"
  - 12 = "December"

  The month names will be localized according to the system's locale settings.

  See Also:
    `toString`, `shortMonthName`, `shortDayName`, `longDayName`

### shortDayName

    public static java.lang.String shortDayName(int weekday)

  Returns the name of the `weekday` using the following convention:

  - 1 = "Mon"
  - 2 = "Tue"
  - 3 = "Wed"
  - 4 = "Thu"
  - 5 = "Fri"
  - 6 = "Sat"
  - 7 = "Sun"

  The day names will be localized according to the system's locale settings.

  See Also:
    `toString`, `shortMonthName`, `longMonthName`, `longDayName`

### shortMonthName

    public static java.lang.String shortMonthName(int month)

  Returns the name of the `month` using the following convention:

  - 1 = "Jan"
  - 2 = "Feb"
  - 3 = "Mar"
  - 4 = "Apr"
  - 5 = "May"
  - 6 = "Jun"
  - 7 = "Jul"
  - 8 = "Aug"
  - 9 = "Sep"
  - 10 = "Oct"
  - 11 = "Nov"
  - 12 = "Dec"

  The month names will be localized according to the system's locale settings.

  See Also:
    `toString`, `longMonthName`, `shortDayName`, `longDayName`

### fromNativePointer

    public static QDate fromNativePointer(QNativePointer nativePointer)

  This function returns the QDate instance pointed to by nativePointer

  Parameters:
    `nativePointer` - the QNativePointer of which object should be returned.

### nativePointerArray

    public static QNativePointer nativePointerArray(QDate[] array)

  This function returns a QNativePointer that is pointing to the specified QDate array.

  Parameters:
    `array` - the array that the returned pointer will point to.
  Returns:
    a QNativePointer that is pointing to the specified array.

### equals

    public boolean equals(java.lang.Object other)

  Overrides:
    `equals` in class `java.lang.Object`

### compareTo

    public int compareTo(java.lang.Object other)

  Specified by:
    `compareTo` in interface `java.lang.Comparable`

### weekNumber

    public final int weekNumber()

  Returns the week number (1 to 53).

  Returns null if the date is invalid.

  In accordance with ISO 8601, weeks start on Qt.DayOfWeek.Monday and the first Qt.DayOfWeek.Thursday of a year is always in week 1 of that year. Most years have 52 weeks, but some have 53.

  Copyright (c) 1989 The Regents of the University of California. All rights reserved.

  Redistribution and use in source and binary forms are permitted provided that the above copyright notice and this paragraph are duplicated in all such forms and that any documentation, advertising materials, and other materials related to such distribution and use acknowledge that the software was developed by the University of California, Berkeley. The name of the University may not be used to endorse or promote products derived from this software without specific prior written permission. THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

### yearOfWeekNumber

    public final int yearOfWeekNumber()

  This function returns the year number of the QDate's current week.

Overview | Package | Class | Tree | Deprecated | Index | Help
Qt Jambi Home |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD